﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace cs
{
    class Karta
    {
        public Barva barva;
        public int vrednost;

        public Karta()
        {
            barva = Barva.NEZNANA;
            vrednost = -1;
        }

        public Karta(Barva _b, int _v)
        {
            barva = _b;
            vrednost = _v;
        }

        public Karta(string s)
        {
            barva = Uporabno.stringVBarvo(s[0]);
            vrednost = Int32.Parse(s.Substring(1));
        }

        public int stTock()
        {
            if (barva != Barva.TAROK)
            {
                switch (vrednost)
                {
                    case 11: return 4;
                    case 12: return 7;
                    case 13: return 10;
                    case 14: return 13;
                    default: return 1;
                }
            }
            else
            {
                if ((vrednost == 1) || (vrednost == 21) || (vrednost == 22)) return 13;
                else return 1;
            }
        }

        public override string ToString()
        {
            return Uporabno.barvaVString(barva) + vrednost.ToString();
        }

        public static bool operator ==(Karta a, Karta b)
        {
            return a.barva == b.barva && a.vrednost == b.vrednost;
        }

        public static bool operator !=(Karta a, Karta b)
        {
            return !(a == b);
        }

        public override bool Equals(object obj)
        {
            if (!(obj is Karta)) return false;
            else return (barva == ((Karta)obj).barva && vrednost == ((Karta)obj).vrednost);
        }

        public override int GetHashCode()
        {
            return 23*(int)(barva) + vrednost;
        }
    }
}
