﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Net.Sockets;

namespace cs
{
    class Program
    {
        static void event_loop(TcpClient cli, StreamReader reader, StreamWriter writer)
        {
            try
            {
                Igralec t;
                Karta[] karte;
                TipIgre tip;
                int pozicija=-1;

                string[] cmda;
                char[] delimiter = new char[] { ' ' };

                while (true)
                {
                    cmda = reader.ReadLine().Split(delimiter);

                    if (cmda[0] == "ADIJO") return;
                    if (cmda[0] == "KONEC_IGRE") continue;
                    if (cmda[0] != "ZACNI") throw new Exception("Napaka v komunikaciji s streznikom.");

                    karte = Uporabno.stringiVKarteN(cmda.Slice(1), out cmda);

                    t = new Igralec();
                    TipIgre predlog = t.zacniIgro(karte);
                    writer.WriteLine("PREDLAGAM " + predlog.ToString());

                    DateTime zacetek = DateTime.Now;

                    while (true)
                    {
                        cmda = reader.ReadLine().Split(delimiter);

                        if (cmda[0] == "ADIJO") return;
                        if (cmda[0] == "KONEC_IGRE")
                        {
                            t.konecIgre(cmda[1]);
                            t = null;
                            karte = null;
                            pozicija = -1;
                            tip = new TipIgre();
                            break;
                        }
                        else if (cmda[0] == "ZALOZI")
                        {
                            int N_grup = Int32.Parse(cmda[1]);
                            Karta[][] talon = new Karta[N_grup][];
                            cmda = cmda.Slice(2);
                            for (int i = 0; i < N_grup; i++)
                            {
                                talon[i] = Uporabno.stringiVKarteN(cmda, out cmda);
                            }
                            Karta[] vzete, zalozene;
                            t.zalozi(karte, talon, out vzete, out zalozene);
                            karte = karte.Union(vzete).Diff(zalozene);
                            writer.WriteLine("LEZIM " + Uporabno.karteVString(vzete) + " " + Uporabno.karteVString(zalozene));
                        }
                        else if (cmda[0] == "IGRAJ")
                        {
                            pozicija = Int32.Parse(cmda[1]);
                            int idxGlavnega = Int32.Parse(cmda[2]);
                            tip = new TipIgre(cmda[3]);
                            Karta[] talon_ostanek = Uporabno.stringiVKarteN(cmda.Slice(4), out cmda);
                            Karta[] talon_pobran = Uporabno.stringiVKarteN(cmda, out cmda);
                            t.zacniRedniDel(pozicija, idxGlavnega, tip, talon_ostanek, talon_pobran);
                            writer.WriteLine("MHM");
                        }
                        else if (cmda[0] == "VRZI")
                        {
                            int prvi_idx = Int32.Parse(cmda[1]);
                            Karta[] karte_na_mizi = Uporabno.stringiVKarteN(cmda.Slice(2), out cmda);
                            Karta karta = t.vrziKarto(karte, karte_na_mizi, prvi_idx);
                            karte = karte.Diff<Karta>(karta);
                            writer.WriteLine("VRZEM " + karta.ToString());
                        }
                        else if (cmda[0] == "POVZETEK")
                        {
                            int prvi_idx = Int32.Parse(cmda[1]);
                            int zmagovalec_idx = Int32.Parse(cmda[2]);
                            Karta[] karte_na_mizi = Uporabno.stringiVKarteN(cmda.Slice(3), out cmda);
                            t.konecKroga(pozicija == zmagovalec_idx, prvi_idx, zmagovalec_idx, karte_na_mizi);
                            writer.WriteLine("MHM");
                        }
                        else
                        {
                            throw new Exception("Napaka v komunikaciji s streznikom.");
                        }
                    }
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("Napaka: " + e.ToString());
            }
        }

        static void timeout_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            System.Environment.Exit(0);
        }

        static TcpClient connect(string hostname, out StreamReader reader, out StreamWriter writer)
        {
            TcpClient client = new TcpClient(hostname, 1179);
            reader = new StreamReader(client.GetStream());
            writer = new StreamWriter(client.GetStream());
            writer.AutoFlush = true;

            string server = reader.ReadLine();
            Console.WriteLine(server);

            writer.WriteLine("AVE " + Igralec.Ime);
            string succ = reader.ReadLine();
            if (succ != "PRIJAVA USPESNA") throw new Exception("Prijava na streznik neuspesna: " + succ);
            return client;
        }

        static void Main(string[] args)
        {
            string hostname;
            if (args.Length < 1) hostname = "localhost";
            else hostname = args[0];

            StreamReader reader;
            StreamWriter writer;
            TcpClient client = connect(hostname, out reader, out writer);
            event_loop(client, reader, writer);
        }
    }
}
