﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace cs
{
    enum Barva { TAROK=0, KARO=1, SRCE=2, KRIZ=3, PIK=4, NEZNANA=-1 };

    class TipIgre
    {
        public int stZalozenihKart;
        public bool solo;
        public Barva klicaniKralj;

        public TipIgre()
        {
            stZalozenihKart = -1;
            solo = false;
            klicaniKralj = Barva.NEZNANA;
        }

        public TipIgre(int _stZalozenihKart, bool _solo, Barva _klicaniKralj)
        {
            stZalozenihKart = _stZalozenihKart;
            solo = _solo;
            klicaniKralj = _klicaniKralj;
        }

        public TipIgre(string t)
        {
            if (t.Length != 3) throw new Exception(t + " ni veljaven opis tipa igre");
            solo = t[0] == 'S';
            stZalozenihKart = t[1] - '0';
            klicaniKralj = Uporabno.stringVBarvo(t[2]);
        }

        public override string ToString()
        {
            string r = "";
            if (solo) r += "S"; else r += "N";
            r += stZalozenihKart.ToString();
            r += Uporabno.barvaVString(klicaniKralj);
            return r;
        }

        public static bool operator == (TipIgre a, TipIgre b)
        {
            return a.stZalozenihKart == b.stZalozenihKart && a.solo == b.solo && a.klicaniKralj == b.klicaniKralj;
        }

        public static bool operator !=(TipIgre a, TipIgre b)
        {
            return !(a == b);
        }

        public int vrednost()
        {
            return solo?90:0 + 30 * (4 - stZalozenihKart);
        }

        public override int GetHashCode()
        {
            throw new NotImplementedException();
        }

        public override bool Equals(object obj)
        {
            throw new NotImplementedException();
        }
    }
}
