﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace cs
{
    static class Uporabno
    {
        public static string karteVString(Karta[] karte)
        {
            string ret = karte.Length.ToString();

            foreach (Karta k in karte)
            {
                ret += " " + k.ToString();
            }

            return ret;
        }

        public static Karta[] stringiVKarteN(string[] opis, out string[] ostanek)
        {
            int N = Int32.Parse(opis[0]);
            ostanek = opis.Slice(N + 1);
            Karta[] karte = new Karta[N];
            for (int i = 0; i < N; i++) karte[i] = new Karta(opis[i + 1]);
            return karte;
        }

        public static int steviloTock(Karta[] karte)
        {
            int sum = 0;
            foreach (Karta k in karte) sum += k.stTock();
            return sum;
        }

        public static Karta[] veljavnePoteze(Karta[] mojeKarte, Karta[] karteNaMizi)
        {
            if (karteNaMizi.Length == 0)
            {
                return mojeKarte;
            }
            else 
            {
                Barva barva = karteNaMizi[0].barva;
                Karta[] enakeBarve = Array.FindAll(mojeKarte, delegate(Karta k) { return k.barva == barva; });
                if (enakeBarve.Length > 0) return enakeBarve;
                Karta[] taroki = Array.FindAll(mojeKarte, delegate(Karta k) { return k.barva == Barva.TAROK; });
                if (taroki.Length > 0) return taroki;
                return mojeKarte;
            }
        }

        public static string barvaVString(Barva b)
        {
            switch (b)
            {
                case Barva.TAROK: return "T";
                case Barva.KARO: return "K";
                case Barva.KRIZ: return "R";
                case Barva.PIK: return "P";
                case Barva.SRCE: return "S";
                case Barva.NEZNANA: return "X";
                default: return "X";
            }
        }

        public static Barva stringVBarvo(char c)
        {
            switch (c)
            {
                case 'T': return Barva.TAROK;
                case 'K': return Barva.KARO;
                case 'R': return Barva.KRIZ;
                case 'P': return Barva.PIK;
                case 'S': return Barva.SRCE;
                default: return Barva.NEZNANA;
            }
        }

        // vir: http://dotnetperls.com/array-slice
        public static T[] Slice<T>(this T[] source, int start, int end)
        {
            // Handles negative ends
            if (end < 0)
            {
                end = source.Length - start - end - 1;
            }
            int len = end - start;

            // Return new array
            T[] res = new T[len];
            for (int i = 0; i < len; i++)
            {
                res[i] = source[i + start];
            }
            return res;
        }

        public static T[] Slice<T>(this T[] source, int start)
        {
            return source.Slice(start, source.Length);
        }

        public static T[] Union<T>(this T[] a, T[] b)
        {
            
            T[] ret = new T[a.Length + b.Length];

            Array.Copy(a, ret, a.Length);
            Array.Copy(b, 0, ret, a.Length, b.Length);

            return ret;
        }

        public static T[] Diff<T>(this T[] a, T[] b)
        {
            return Array.FindAll(a,
                delegate (T t) {
                    return !b.Contains(t);
                });
        }

        public static Karta[] Diff<T>(this Karta[] a, Karta b)
        {
            return Array.FindAll(a,
                delegate(Karta t)
                {
                    return t != b;
                });
        }
        
    }
}
